#!/usr/bin/env python
'''
an enemy sprite class
'''
import random
import pygame
from sprite import *

class enemy(sprite):
    '''
    an enemy sprite class
    '''
    def __init__(self, loc, pic, idno, speed=2):
        ''' initilize enemy base class
            pic = pygame surface of enemy sprite
            loc[0] = x location on map
            loc[1] = y locaiton on map    
        '''
        sprite.__init__(self,pic,loc[0],loc[1])
        self.loc = loc
        #print self.loc
        self.speed = speed
        self.ENEMYTYPE = -1
        self.mapstate = [
            [0,0,0],
            [0,0,0],
            [0,0,0]
        ]    # Map state around enemy
        self.otherstate = [
            [0,0,0],
            [0,0,0],
            [0,0,0]
        ]
        self.idno = idno    # ID number of this enemy
        self.splatpic = [3,10]
    
    def render(self, screen, loc):
        ''' render to the screen '''
        screen.blit(self.pic, loc)
    
    def update(self):
        ''' runs update logic for this enemy
            made to be superseded by all enemy types
        '''
        pass
    
    def move(self):
        ''' default is a random move or not move '''
        random.seed()
        movedir = random.randint(0,4)
        if movedir == 0:
            return
        elif movedir == 1:
            ''' Up '''
            if(self.isValid(self.mapstate[1][0]) and self.otherstate[1][0] == 0):
                self.loc[1] = self.loc[1] - 1
        elif movedir == 2:
            if(self.isValid(self.mapstate[1][2]) and self.otherstate[1][2] == 0):
                self.loc[1] = self.loc[1] + 1
        elif movedir == 3:
            if(self.isValid(self.mapstate[0][1]) and self.otherstate[0][1] == 0):
                self.loc[0] = self.loc[0] - 1
        elif movedir == 4:
            if(self.isValid(self.mapstate[2][1]) and self.otherstate[2][1] == 0):
                self.loc[0] = self.loc[0] + 1
    
    def isValid(self, ttype):
        ''' checks if a specific tile type is a valid move
            made to be superseded by all enemy types
        '''
        return True
    
    def splat(self):
        ''' called when monster is destroyed *** SPLATTED *** '''
        pygame.event.post(pygame.event.Event(USEREVENT,
                                             uetype="splat",
                                             loc = self.loc,
                                             splattype = 1,
                                             pic = self.splatpic))
    
    def nextToPlayer(self):
        ''' returns true if player is next to enemy '''
        for x in xrange(0,3):
            for y in xrange(0,3):
                if self.otherstate[x][y] == 999:
                    return True
        return False